	$modxx51
ad_WRaRD	equ	P3.0	;vstupy WR a RD A/D prevodniku
c_R	equ	P3.1	;reset citacu
ram_WR	equ	P3.4	;zapisovaci pulzy pro SRAM
ram_OE_c_CLK	equ	P3.5	;vstup OE pameti SRAM a CLK vstup citace
buf_CLK	equ	P3.7	;nacitaci vstup stradace
;cudl +	equ	P3.2	;tlacitko -
;cudl -	equ	P3.3	;tlacitko +
E	equ	P1.0	;hodinovy vstup LCD
RS	equ	P1.1	;volba instrukce/data pro LCD
;D4-D7	equ	P1.4-P1.7

Timer	equ	(256)-28	;vzorkovaci frekvence 35kHz
Konst1	equ	179	
Konst2	equ	2	;Konst1*Konst2*Timer = 10,024ms

	bseg	at 20h
Nuly:	dbit	1
CanRead:	dbit	1
DelaYx2:	dbit	1
Nasobitel:	dbit	1

	dseg	at 30h
Zasobnik:	ds	50
Delay:	ds	1
Cifra:	ds	1
c12:	ds	1
c34:	ds	1
	
	cseg
	org	0	;init
	jmp	Init
	org	003h	;cudl +
	jmp	Pricti
	org	00bh	;Timer
	jmp	Vzorek
	org	013h	;cudl -
	jmp	Odecti
	;inicializace
Init:	mov	sp,#Zasobnik
	mov	P1,#255
	mov	P3,#255
	mov	Delay,#10	;vychozi nastaveni zpozdeni
	clr	DelaYx2
	acall	DelaySet
	clr	c_R
	clr	CanRead
	;inicializace displeje
	acall	delay3
	mov	a,#00100000b
	acall	PosliInstr
	mov	a,#00000110b
	acall	PosliInstr
	mov	a,#00001100b
	acall	PosliInstr
	;smaz displej
	mov	a,#00000001b
	acall	PosliInstr
	;napis neco
	acall	PisDelay
	;povoleni preruseni a nasteveni citace
	mov	tmod,#00000010b
	mov	th0,#Timer
	mov	tl0,#Timer	
	setb	ea
	clr	es
	setb	ex0
	setb	it0
	setb	ex1
	setb	it1
	setb	et0
	setb	tr0

	jmp	$
	;inicializace casovacich promennych
DelaySet:	mov	R7,#Konst1
	mov	R6,#Konst2
	mov	R5,Delay
	mov	c,DelaYx2
	mov	Nasobitel,c
	ret
	;kontrola obsahu Delay
	;pro pricitani
SediDelayInc:	mov	R5,Delay
	jb	DelaYx2,PulInc
	cjne	R5,#255,NicInc
	setb	DelaYx2
NicInc:	inc	Delay
	ret
PulInc:	cjne	R5,#110,NicInc
	ret
	;pro odecitani
SediDelayDec:	mov	R5,Delay
	jnb	DelaYx2,PulDec
	cjne	R5,#0,NicDec
	clr	DelaYx2
NicDec:	dec	Delay
	ret
PulDec:	cjne	R5,#1,NicDec
	ret
	;pricti 10ms
Pricti:	clr	tr0
	acall	SediDelayInc
	acall	PisDelay
	mov	R3,#0
MoznaIncAuto:	djnz	R3,NeIncAuto
IncAuto:	acall	SediDelayInc
	acall	PisDelay
	acall	Delay2
	acall	Delay2
	acall	Delay2
	acall	Delay2	
	jnb	P3.2,IncAuto
	jmp	KonecIncAuto	
NeIncAuto:	call	Delay2
	jnb	P3.2,MoznaIncAuto
KonecIncAuto:	call	Delay2
	jnb	P3.2,$
	clr	CanRead
	acall	DelaySet
	clr	ie0
	setb	tr0
	reti
	;odecti 10ms
Odecti:	clr	tr0
	acall	SediDelayDec
	acall	PisDelay
	mov	R3,#0
MoznadecAuto:	djnz	R3,NedecAuto
decAuto:	acall	SediDelayDec
	acall	PisDelay
	acall	Delay2
	acall	Delay2
	acall	Delay2
	acall	Delay2	
	jnb	P3.3,decAuto
	jmp	KonecdecAuto	
NedecAuto:	call	Delay2
	jnb	P3.3,MoznadecAuto
KonecdecAuto:	call	Delay2
	jnb	P3.3,$
	clr	CanRead
	acall	DelaySet
	clr	ie1
	setb	tr0
	reti
	;napis na displej zpozdeni
	;prevod na BCD
PisDelay:	mov	R1,Delay
	mov	c,DelaYx2
	clr	a
	mov	acc.0,c
	mov	R2,a
	mov	c12,#00h
	mov	c34,#00h
	mov	R4,#16
Makej:	mov	a,R1
	add	a,acc
	mov	R1,a
	mov	a,R2
	rlc	a
	mov	R2,a
	mov	a,c12
	addc	a,acc
	da	a
	mov	c12,a
	mov	a,c34
	addc	a,acc
	da	a
	mov	c34,a
	djnz	R4,Makej
	;posli na displej
	mov	Cifra,#1
	setb	Nuly
	;korzor na zacatek
	mov	a,#00000010b
	acall	PosliInstr
	;posilat cisla
	mov	a,c34
	acall	PosliDelay
	mov	a,c12
	acall	PosliDelay
	mov	a,#'0'
	acall	PosliData
	mov	a,#' '
	acall	PosliData
	mov	a,#'m'
	acall	PosliData
	mov	a,#'s'
	acall	PosliData
	ret
	;posli cislo na displej
	;de BCD
PosliDelay:	push	acc
	anl	a,#11110000b
	swap	a
	acall	PosliDelay1
	pop	acc
	anl	a,#00001111b
	acall	PosliDelay1
	ret
	;poslat a potlacit nuly na zacatku
PosliDelay1:	mov	R0,a
	jz	JesteNula
	clr	Nuly
	jmp	JoNula
JesteNula:	jnb	Nuly,JoNula
	mov	a,#' '
	jmp	NeNula
JoNula:	mov	a,R0
	add	a,#48
NeNula:	acall	PosliData
	inc	Cifra
	ret
	;dalsi vzorek
Vzorek:	clr	ram_OE_c_CLK
	jnb	CanRead,Necti	;tohle aby se neprehravala prazdna pamet (sum)
	clr	buf_CLK
	setb	buf_CLK
Necti:	setb	ram_OE_c_CLK
	;zapis novy a spust novy prevod
	clr	ad_WRaRD
	clr	ram_WR
	setb	ram_WR
	setb	ad_WRaRD
	;utipnout citac?
	;pocitadlo kery dela natvrdo 10ms
	djnz	R7,JesteNe
	mov	R7,#Konst1
	djnz	R6,JesteNe
	mov	R6,#Konst2
	;pocitadlo nastavitelne na Delay*10ms a DelaYx2 ho 2*zvetsuje
	djnz	R5,JesteNe
	jbc	Nasobitel,JesteNe
	mov	c,DelaYx2
	mov	Nasobitel,c
	mov	R5,Delay
	;reset citac nuluj citace
	setb	CanRead
	setb	c_R
	clr	c_R
JesteNe:	reti
	;posli data na displej
PosliData:	setb	RS
	push	acc
	acall	CtiP1
	pop	acc
	swap	a
	acall	CtiP1
	acall	Delay1
	ret
	;posli instrukci displeji
PosliInstr:	clr	RS
	push	acc
	acall	CtiP1
	pop	acc
	swap	a
	acall	CtiP1
	acall	Delay2
	ret
	;rozdeleni 8bit. slova na 2 4bit. pro 4bit komunikaci
CtiP1:	anl	a,#11110000b
	mov	R4,a
	mov	a,P1
	anl	a,#00001111b
	orl	a,R4
	mov	P1,a
	nop
	setb	E
	nop
	clr	E
	ret
	;zpozdeni cca 512us
Delay1:	mov	R0,#0
	djnz	R0,$
	ret
	;zpozdeni cca 2048us
Delay2:	acall	Delay1
	acall	Delay1
	acall	Delay1
	acall	Delay1
	ret
	;zpozdeni cca 25,6ms
Delay3:	mov	b,#50
LoopDelay3:	acall	Delay1
	djnz	b,LoopDelay3
	ret
	;konec :-)
	end